/* ==== graphics.c ==== */
/*  Part of the source of the program "SDL-Toms", a puzzle game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/#sdl-toms
    Current email address: tomble@usermail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */




#include <stdlib.h>
#include "sdl-toms.h"
SDL_Surface *atom_surfaces[8*MAX_PLAYERS];
/* Should actually have up to 4 players, but not yet */
SDL_Surface *main_surf;
SDL_Surface *expl_surf;

char fname[20];

void init_graphics() {
   SDL_Rect trect;
   int p,a;
   SDL_Init(SDL_INIT_VIDEO); /* if return is -1, failed */
   atexit(SDL_Quit);
   main_surf=SDL_SetVideoMode(640,480,16,SDL_SWSURFACE|SDL_FULLSCREEN);
   expl_surf=IMG_Load("explode.png");
   if(expl_surf==NULL) {
      fprintf(stderr,"Couldn't init explode.png\n");
      exit(1);
   }
   for(p=0;p<MAX_PLAYERS;p++) {
      for(a=0;a<8;a++) {
         sprintf(fname,"atom_p%d_n%d.xpm",p,a);
         atom_surfaces[(p*8)+a]=
         IMG_Load(fname);
         if(atom_surfaces[(p*8)+a]==NULL) {
            fprintf(stderr,"Couldn't init image p%d_n%d.\n",p,a);
         }
      }
   }
   trect.x=7;trect.y=7;
   trect.w=625;trect.h=391;
   SDL_FillRect(main_surf,&trect,0xFFFF);
   trect.h=38;trect.w=38;
   for(p=0;p<16;p++)
     for(a=0;a<10;a++) {
        GET_RECT(p,a,trect);
        SDL_FillRect(main_surf,&trect,0x0000);
     }
   SDL_Flip(main_surf);
}

SDL_Surface *at_surf(int player, int atoms) {
   fprintf(stderr,"no atoms: %d\n",atoms);
   return(atom_surfaces[(player*8)+atoms]);
}

