/* ==== sdl-toms.h ==== */
/*  Part of the source of the program "SDL-Toms", a puzzle game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/#sdl-toms
    Current email address: tomble@usermail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */




#include "SDL.h"
#include "SDL_image.h"

#define MAX_PLAYERS 2

#define GET_RECT(col,row,rect) (rect.x=8+(39*col)),(rect.y=8+(39*row))

struct udlist_t { /* cells that need updating */
   int Col; /* Column this element uses */
   int Extra[10]; /* Array of how many atoms each
                  cell of this column gains. Should be
                  initialised to 0 when this element created */
   struct udlist_t *Next; /* next column with gains */
};
typedef struct udlist_t udlist_t;

struct ulist_t{
   int Idx; /* Index of cell that's unstable */
   int Gl; /* whether or not an atom will be shot to the left */
   int Gr; /* """"" right */
   int Gu; /* """"" up */
   int Gd; /* """"" down */
   int Freeit; /* 0 if from an array */
   struct ulist_t *Next; /* next in list */
};
typedef struct ulist_t ulist_t;

/* protos */
/* chain.c*/
void do_chain(int playerno);
void new_unstable(int i); /* appends item to list */
void new_update(int index);
ulist_t *get_unstable();
void free_unstable(ulist_t *u);
udlist_t *get_update(); /*NEVER mallocs */
void free_update(); /* just changes a counter */


/* main.c, graphics.c */
void game_loop();
void init_graphics();
SDL_Surface *at_surf(int player,int atoms);


/* externs */
extern int cells[];
/* number of atoms in a cell */
extern int pcell[];
/* player who owns cell */

extern ulist_t *unstable_list;

extern SDL_Surface *main_surf;
extern SDL_Surface *expl_surf;
